<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>19.1. email — An email and MIME handling package &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="19. Internet Data Handling" href="netdata.html" />
    <link rel="next" title="19.1.1. email.message: Representing an email message" href="email.message.html" />
    <link rel="prev" title="19. Internet Data Handling" href="netdata.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="email.message.html" title="19.1.1. email.message: Representing an email message"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="netdata.html" title="19. Internet Data Handling"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="netdata.html" accesskey="U">19. Internet Data Handling</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-email">
<span id="email-an-email-and-mime-handling-package"></span><h1>19.1. <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> &#8212; An email and MIME handling package<a class="headerlink" href="#module-email" title="Permalink to this headline">¶</a></h1>
<p>The <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package is a library for managing email messages, including
MIME and other <span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2822.html"><strong>RFC 2822</strong></a>-based message documents.  It is specifically <em>not</em>
designed to do any sending of email messages to SMTP (<span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2821.html"><strong>RFC 2821</strong></a>), NNTP, or
other servers; those are functions of modules such as <a class="reference internal" href="smtplib.html#module-smtplib" title="smtplib: SMTP protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">smtplib</span></code></a> and
<a class="reference internal" href="nntplib.html#module-nntplib" title="nntplib: NNTP protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">nntplib</span></code></a>. The <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package attempts to be as RFC-compliant as
possible, supporting in addition to <span class="target" id="index-2"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2822.html"><strong>RFC 2822</strong></a>, such MIME-related RFCs as
<span class="target" id="index-3"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2045.html"><strong>RFC 2045</strong></a>, <span class="target" id="index-4"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2046.html"><strong>RFC 2046</strong></a>, <span class="target" id="index-5"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2047.html"><strong>RFC 2047</strong></a>, and <span class="target" id="index-6"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2231.html"><strong>RFC 2231</strong></a>.</p>
<p>The primary distinguishing feature of the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package is that it splits
the parsing and generating of email messages from the internal <em>object model</em>
representation of email.  Applications using the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package deal
primarily with objects; you can add sub-objects to messages, remove sub-objects
from messages, completely re-arrange the contents, etc.  There is a separate
parser and a separate generator which handles the transformation from flat text
to the object model, and then back to flat text again.  There are also handy
subclasses for some common MIME object types, and a few miscellaneous utilities
that help with such common tasks as extracting and parsing message field values,
creating RFC-compliant dates, etc.</p>
<p>The following sections describe the functionality of the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package.
The ordering follows a progression that should be common in applications: an
email message is read as flat text from a file or other source, the text is
parsed to produce the object structure of the email message, this structure is
manipulated, and finally, the object tree is rendered back into flat text.</p>
<p>It is perfectly feasible to create the object structure out of whole cloth &#8212;
i.e. completely from scratch.  From there, a similar progression can be taken as
above.</p>
<p>Also included are detailed specifications of all the classes and modules that
the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package provides, the exception classes you might encounter
while using the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package, some auxiliary utilities, and a few
examples.  For users of the older <code class="xref py py-mod docutils literal"><span class="pre">mimelib</span></code> package, or previous versions
of the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package, a section on differences and porting is provided.</p>
<p>Contents of the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package documentation:</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="email.message.html">19.1.1. <code class="docutils literal"><span class="pre">email.message</span></code>: Representing an email message</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.parser.html">19.1.2. <code class="docutils literal"><span class="pre">email.parser</span></code>: Parsing email messages</a><ul>
<li class="toctree-l2"><a class="reference internal" href="email.parser.html#feedparser-api">19.1.2.1. FeedParser API</a></li>
<li class="toctree-l2"><a class="reference internal" href="email.parser.html#parser-class-api">19.1.2.2. Parser class API</a></li>
<li class="toctree-l2"><a class="reference internal" href="email.parser.html#additional-notes">19.1.2.3. Additional notes</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="email.generator.html">19.1.3. <code class="docutils literal"><span class="pre">email.generator</span></code>: Generating MIME documents</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.policy.html">19.1.4. <code class="docutils literal"><span class="pre">email.policy</span></code>: Policy Objects</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.headerregistry.html">19.1.5. <code class="docutils literal"><span class="pre">email.headerregistry</span></code>: Custom Header Objects</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.contentmanager.html">19.1.6. <code class="docutils literal"><span class="pre">email.contentmanager</span></code>: Managing MIME Content</a><ul>
<li class="toctree-l2"><a class="reference internal" href="email.contentmanager.html#content-manager-instances">19.1.6.1. Content Manager Instances</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="email.mime.html">19.1.7. <code class="docutils literal"><span class="pre">email.mime</span></code>: Creating email and MIME objects from scratch</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.header.html">19.1.8. <code class="docutils literal"><span class="pre">email.header</span></code>: Internationalized headers</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.charset.html">19.1.9. <code class="docutils literal"><span class="pre">email.charset</span></code>: Representing character sets</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.encoders.html">19.1.10. <code class="docutils literal"><span class="pre">email.encoders</span></code>: Encoders</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.errors.html">19.1.11. <code class="docutils literal"><span class="pre">email.errors</span></code>: Exception and Defect classes</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.util.html">19.1.12. <code class="docutils literal"><span class="pre">email.utils</span></code>: Miscellaneous utilities</a></li>
<li class="toctree-l1"><a class="reference internal" href="email.iterators.html">19.1.13. <code class="docutils literal"><span class="pre">email.iterators</span></code>: Iterators</a></li>
<li class="toctree-l1"><a class="reference internal" href="email-examples.html">19.1.14. <code class="docutils literal"><span class="pre">email</span></code>: Examples</a><ul>
<li class="toctree-l2"><a class="reference internal" href="email-examples.html#examples-using-the-provisional-api">19.1.14.1. Examples using the Provisional API</a></li>
</ul>
</li>
</ul>
</div>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt>Module <a class="reference internal" href="smtplib.html#module-smtplib" title="smtplib: SMTP protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">smtplib</span></code></a></dt>
<dd>SMTP protocol client</dd>
<dt>Module <a class="reference internal" href="nntplib.html#module-nntplib" title="nntplib: NNTP protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">nntplib</span></code></a></dt>
<dd>NNTP protocol client</dd>
</dl>
</div>
<div class="section" id="package-history">
<span id="email-pkg-history"></span><h2>19.1.15. Package History<a class="headerlink" href="#package-history" title="Permalink to this headline">¶</a></h2>
<p>This table describes the release history of the email package, corresponding to
the version of Python that the package was released with.  For purposes of this
document, when you see a note about change or added versions, these refer to the
Python version the change was made in, <em>not</em> the email package version.  This
table also describes the Python compatibility of each version of the package.</p>
<table border="1" class="docutils">
<colgroup>
<col width="22%" />
<col width="44%" />
<col width="34%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">email version</th>
<th class="head">distributed with</th>
<th class="head">compatible with</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">1.x</span></code></td>
<td>Python 2.2.0 to Python 2.2.1</td>
<td><em>no longer supported</em></td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">2.5</span></code></td>
<td>Python 2.2.2+ and Python 2.3</td>
<td>Python 2.1 to 2.5</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">3.0</span></code></td>
<td>Python 2.4 and Python 2.5</td>
<td>Python 2.3 to 2.6</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">4.0</span></code></td>
<td>Python 2.5 to Python 2.7</td>
<td>Python 2.3 to 2.7</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">5.0</span></code></td>
<td>Python 3.0 and Python 3.1</td>
<td>Python 3.0 to 3.2</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">5.1</span></code></td>
<td>Python 3.2</td>
<td>Python 3.2</td>
</tr>
</tbody>
</table>
<p>After Version 5.1 (Python 3.2), the email package no longer has a version that
is separate from the Python version.  (See the <a class="reference internal" href="../whatsnew/index.html#whatsnew-index"><span>What&#8217;s New in Python</span></a> documents
for the respective Python versions for details on changes.)</p>
<p>Here are the major differences between <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> version 5.1 and
version 5.0:</p>
<ul class="simple">
<li>It is once again possible to parse messages containing non-ASCII bytes,
and to reproduce such messages if the data containing the non-ASCII
bytes is not modified.</li>
<li>New functions <a class="reference internal" href="email.parser.html#email.message_from_bytes" title="email.message_from_bytes"><code class="xref py py-func docutils literal"><span class="pre">message_from_bytes()</span></code></a> and <a class="reference internal" href="email.parser.html#email.message_from_binary_file" title="email.message_from_binary_file"><code class="xref py py-func docutils literal"><span class="pre">message_from_binary_file()</span></code></a>,
and new classes <a class="reference internal" href="email.parser.html#email.parser.BytesFeedParser" title="email.parser.BytesFeedParser"><code class="xref py py-class docutils literal"><span class="pre">BytesFeedParser</span></code></a> and
<a class="reference internal" href="email.parser.html#email.parser.BytesParser" title="email.parser.BytesParser"><code class="xref py py-class docutils literal"><span class="pre">BytesParser</span></code></a> allow binary message data to be parsed
into model objects.</li>
<li>Given bytes input to the model, <a class="reference internal" href="email.message.html#email.message.Message.get_payload" title="email.message.Message.get_payload"><code class="xref py py-meth docutils literal"><span class="pre">get_payload()</span></code></a>
will by default decode a message body that has a
<em class="mailheader">Content-Transfer-Encoding</em> of <code class="docutils literal"><span class="pre">8bit</span></code> using the charset
specified in the MIME headers and return the resulting string.</li>
<li>Given bytes input to the model, <a class="reference internal" href="email.generator.html#email.generator.Generator" title="email.generator.Generator"><code class="xref py py-class docutils literal"><span class="pre">Generator</span></code></a> will
convert message bodies that have a <em class="mailheader">Content-Transfer-Encoding</em> of
8bit to instead have a 7bit Content-Transfer-Encoding.</li>
<li>New class <a class="reference internal" href="email.generator.html#email.generator.BytesGenerator" title="email.generator.BytesGenerator"><code class="xref py py-class docutils literal"><span class="pre">BytesGenerator</span></code></a> produces bytes
as output, preserving any unchanged non-ASCII data that was
present in the input used to build the model, including message bodies
with a <em class="mailheader">Content-Transfer-Encoding</em> of 8bit.</li>
</ul>
<p>Here are the major differences between <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> version 5.0 and version 4:</p>
<ul class="simple">
<li>All operations are on unicode strings.  Text inputs must be strings,
text outputs are strings.  Outputs are limited to the ASCII character
set and so can be encoded to ASCII for transmission.  Inputs are also
limited to ASCII; this is an acknowledged limitation of email 5.0 and
means it can only be used to parse email that is 7bit clean.</li>
</ul>
<p>Here are the major differences between <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> version 4 and version 3:</p>
<ul>
<li><p class="first">All modules have been renamed according to <span class="target" id="index-7"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0008"><strong>PEP 8</strong></a> standards.  For example,
the version 3 module <code class="xref py py-mod docutils literal"><span class="pre">email.Message</span></code> was renamed to <a class="reference internal" href="email.message.html#module-email.message" title="email.message: The base class representing email messages."><code class="xref py py-mod docutils literal"><span class="pre">email.message</span></code></a> in
version 4.</p>
</li>
<li><p class="first">A new subpackage <a class="reference internal" href="email.mime.html#module-email.mime" title="email.mime: Build MIME messages."><code class="xref py py-mod docutils literal"><span class="pre">email.mime</span></code></a> was added and all the version 3
<code class="xref py py-mod docutils literal"><span class="pre">email.MIME*</span></code> modules were renamed and situated into the <a class="reference internal" href="email.mime.html#module-email.mime" title="email.mime: Build MIME messages."><code class="xref py py-mod docutils literal"><span class="pre">email.mime</span></code></a>
subpackage.  For example, the version 3 module <code class="xref py py-mod docutils literal"><span class="pre">email.MIMEText</span></code> was renamed
to <code class="xref py py-mod docutils literal"><span class="pre">email.mime.text</span></code>.</p>
<p><em>Note that the version 3 names will continue to work until Python 2.6</em>.</p>
</li>
<li><p class="first">The <code class="xref py py-mod docutils literal"><span class="pre">email.mime.application</span></code> module was added, which contains the
<a class="reference internal" href="email.mime.html#email.mime.application.MIMEApplication" title="email.mime.application.MIMEApplication"><code class="xref py py-class docutils literal"><span class="pre">MIMEApplication</span></code></a> class.</p>
</li>
<li><p class="first">Methods that were deprecated in version 3 have been removed.  These include
<code class="xref py py-meth docutils literal"><span class="pre">Generator.__call__()</span></code>, <code class="xref py py-meth docutils literal"><span class="pre">Message.get_type()</span></code>,
<code class="xref py py-meth docutils literal"><span class="pre">Message.get_main_type()</span></code>, <code class="xref py py-meth docutils literal"><span class="pre">Message.get_subtype()</span></code>.</p>
</li>
<li><p class="first">Fixes have been added for <span class="target" id="index-8"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc2231.html"><strong>RFC 2231</strong></a> support which can change some of the
return types for <a class="reference internal" href="email.message.html#email.message.Message.get_param" title="email.message.Message.get_param"><code class="xref py py-func docutils literal"><span class="pre">Message.get_param</span></code></a>
and friends.  Under some
circumstances, values which used to return a 3-tuple now return simple strings
(specifically, if all extended parameter segments were unencoded, there is no
language and charset designation expected, so the return type is now a simple
string).  Also, %-decoding used to be done for both encoded and unencoded
segments; this decoding is now done only for encoded segments.</p>
</li>
</ul>
<p>Here are the major differences between <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> version 3 and version 2:</p>
<ul class="simple">
<li>The <a class="reference internal" href="email.parser.html#email.parser.FeedParser" title="email.parser.FeedParser"><code class="xref py py-class docutils literal"><span class="pre">FeedParser</span></code></a> class was introduced, and the
<a class="reference internal" href="email.parser.html#email.parser.Parser" title="email.parser.Parser"><code class="xref py py-class docutils literal"><span class="pre">Parser</span></code></a> class was implemented in terms of the
<a class="reference internal" href="email.parser.html#email.parser.FeedParser" title="email.parser.FeedParser"><code class="xref py py-class docutils literal"><span class="pre">FeedParser</span></code></a>.  All parsing therefore is
non-strict, and parsing will make a best effort never to raise an exception.
Problems found while parsing messages are stored in the message&#8217;s <em>defect</em>
attribute.</li>
<li>All aspects of the API which raised <a class="reference internal" href="exceptions.html#DeprecationWarning" title="DeprecationWarning"><code class="xref py py-exc docutils literal"><span class="pre">DeprecationWarning</span></code></a>s in version 2
have been removed.  These include the <em>_encoder</em> argument to the
<a class="reference internal" href="email.mime.html#email.mime.text.MIMEText" title="email.mime.text.MIMEText"><code class="xref py py-class docutils literal"><span class="pre">MIMEText</span></code></a> constructor, the
<code class="xref py py-meth docutils literal"><span class="pre">Message.add_payload()</span></code> method, the <code class="xref py py-func docutils literal"><span class="pre">Utils.dump_address_pair()</span></code>
function, and the functions <code class="xref py py-func docutils literal"><span class="pre">Utils.decode()</span></code> and <code class="xref py py-func docutils literal"><span class="pre">Utils.encode()</span></code>.</li>
<li>New <a class="reference internal" href="exceptions.html#DeprecationWarning" title="DeprecationWarning"><code class="xref py py-exc docutils literal"><span class="pre">DeprecationWarning</span></code></a>s have been added to:
<code class="xref py py-meth docutils literal"><span class="pre">Generator.__call__()</span></code>, <code class="xref py py-meth docutils literal"><span class="pre">Message.get_type()</span></code>,
<code class="xref py py-meth docutils literal"><span class="pre">Message.get_main_type()</span></code>, <code class="xref py py-meth docutils literal"><span class="pre">Message.get_subtype()</span></code>, and the <em>strict</em>
argument to the <a class="reference internal" href="email.parser.html#email.parser.Parser" title="email.parser.Parser"><code class="xref py py-class docutils literal"><span class="pre">Parser</span></code></a> class.  These are expected to
be removed in future versions.</li>
<li>Support for Pythons earlier than 2.3 has been removed.</li>
</ul>
<p>Here are the differences between <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> version 2 and version 1:</p>
<ul>
<li><p class="first">The <code class="xref py py-mod docutils literal"><span class="pre">email.Header</span></code> and <code class="xref py py-mod docutils literal"><span class="pre">email.Charset</span></code> modules have been added.</p>
</li>
<li><p class="first">The pickle format for <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> instances has changed.
Since this was never (and still isn&#8217;t) formally defined, this isn&#8217;t
considered a backward incompatibility.  However if your application pickles
and unpickles <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> instances, be aware that in
<a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> version 2, <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> instances now have
private variables <em>_charset</em> and <em>_default_type</em>.</p>
</li>
<li><p class="first">Several methods in the <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> class have been
deprecated, or their signatures changed.  Also, many new methods have been
added.  See the documentation for the <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> class
for details.  The changes should be completely backward compatible.</p>
</li>
<li><p class="first">The object structure has changed in the face of <em class="mimetype">message/rfc822</em>
content types.  In <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> version 1, such a type would be represented
by a scalar payload, i.e. the container message&#8217;s
<a class="reference internal" href="email.message.html#email.message.Message.is_multipart" title="email.message.Message.is_multipart"><code class="xref py py-meth docutils literal"><span class="pre">is_multipart()</span></code></a> returned false,
<a class="reference internal" href="email.message.html#email.message.Message.get_payload" title="email.message.Message.get_payload"><code class="xref py py-meth docutils literal"><span class="pre">get_payload()</span></code></a> was not a list object, but a
single <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> instance.</p>
<p>This structure was inconsistent with the rest of the package, so the object
representation for <em class="mimetype">message/rfc822</em> content types was changed.  In
<a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> version 2, the container <em>does</em> return <code class="docutils literal"><span class="pre">True</span></code> from
<a class="reference internal" href="email.message.html#email.message.Message.is_multipart" title="email.message.Message.is_multipart"><code class="xref py py-meth docutils literal"><span class="pre">is_multipart()</span></code></a>, and
<a class="reference internal" href="email.message.html#email.message.Message.get_payload" title="email.message.Message.get_payload"><code class="xref py py-meth docutils literal"><span class="pre">get_payload()</span></code></a> returns a list containing a single
<a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> item.</p>
<p>Note that this is one place that backward compatibility could not be
completely maintained.  However, if you&#8217;re already testing the return type of
<a class="reference internal" href="email.message.html#email.message.Message.get_payload" title="email.message.Message.get_payload"><code class="xref py py-meth docutils literal"><span class="pre">get_payload()</span></code></a>, you should be fine.  You just need
to make sure your code doesn&#8217;t do a <a class="reference internal" href="email.message.html#email.message.Message.set_payload" title="email.message.Message.set_payload"><code class="xref py py-meth docutils literal"><span class="pre">set_payload()</span></code></a>
with a <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> instance on a container with a content
type of <em class="mimetype">message/rfc822</em>.</p>
</li>
<li><p class="first">The <a class="reference internal" href="email.parser.html#email.parser.Parser" title="email.parser.Parser"><code class="xref py py-class docutils literal"><span class="pre">Parser</span></code></a> constructor&#8217;s <em>strict</em> argument was added,
and its <a class="reference internal" href="email.parser.html#email.parser.Parser.parse" title="email.parser.Parser.parse"><code class="xref py py-meth docutils literal"><span class="pre">parse()</span></code></a> and
<a class="reference internal" href="email.parser.html#email.parser.Parser.parsestr" title="email.parser.Parser.parsestr"><code class="xref py py-meth docutils literal"><span class="pre">parsestr()</span></code></a> methods grew a <em>headersonly</em> argument.
The <em>strict</em> flag was also added to functions <a class="reference internal" href="email.parser.html#email.message_from_file" title="email.message_from_file"><code class="xref py py-func docutils literal"><span class="pre">email.message_from_file()</span></code></a>
and <a class="reference internal" href="email.parser.html#email.message_from_string" title="email.message_from_string"><code class="xref py py-func docutils literal"><span class="pre">email.message_from_string()</span></code></a>.</p>
</li>
<li><p class="first"><code class="xref py py-meth docutils literal"><span class="pre">Generator.__call__()</span></code> is deprecated; use <a class="reference internal" href="email.generator.html#email.generator.Generator.flatten" title="email.generator.Generator.flatten"><code class="xref py py-meth docutils literal"><span class="pre">Generator.flatten</span></code></a> instead.  The
<a class="reference internal" href="email.generator.html#email.generator.Generator" title="email.generator.Generator"><code class="xref py py-class docutils literal"><span class="pre">Generator</span></code></a> class has also grown the
<a class="reference internal" href="email.generator.html#email.generator.Generator.clone" title="email.generator.Generator.clone"><code class="xref py py-meth docutils literal"><span class="pre">clone()</span></code></a> method.</p>
</li>
<li><p class="first">The <a class="reference internal" href="email.generator.html#email.generator.DecodedGenerator" title="email.generator.DecodedGenerator"><code class="xref py py-class docutils literal"><span class="pre">DecodedGenerator</span></code></a> class in the
<a class="reference internal" href="email.generator.html#module-email.generator" title="email.generator: Generate flat text email messages from a message structure."><code class="xref py py-mod docutils literal"><span class="pre">email.generator</span></code></a> module was added.</p>
</li>
<li><p class="first">The intermediate base classes
<a class="reference internal" href="email.mime.html#email.mime.nonmultipart.MIMENonMultipart" title="email.mime.nonmultipart.MIMENonMultipart"><code class="xref py py-class docutils literal"><span class="pre">MIMENonMultipart</span></code></a> and
<a class="reference internal" href="email.mime.html#email.mime.multipart.MIMEMultipart" title="email.mime.multipart.MIMEMultipart"><code class="xref py py-class docutils literal"><span class="pre">MIMEMultipart</span></code></a> have been added, and interposed
in the class hierarchy for most of the other MIME-related derived classes.</p>
</li>
<li><p class="first">The <em>_encoder</em> argument to the <a class="reference internal" href="email.mime.html#email.mime.text.MIMEText" title="email.mime.text.MIMEText"><code class="xref py py-class docutils literal"><span class="pre">MIMEText</span></code></a> constructor
has been deprecated.  Encoding  now happens implicitly based on the
<em>_charset</em> argument.</p>
</li>
<li><p class="first">The following functions in the <code class="xref py py-mod docutils literal"><span class="pre">email.Utils</span></code> module have been deprecated:
<code class="xref py py-func docutils literal"><span class="pre">dump_address_pairs()</span></code>, <code class="xref py py-func docutils literal"><span class="pre">decode()</span></code>, and <code class="xref py py-func docutils literal"><span class="pre">encode()</span></code>.  The following
functions have been added to the module: <code class="xref py py-func docutils literal"><span class="pre">make_msgid()</span></code>,
<code class="xref py py-func docutils literal"><span class="pre">decode_rfc2231()</span></code>, <code class="xref py py-func docutils literal"><span class="pre">encode_rfc2231()</span></code>, and <code class="xref py py-func docutils literal"><span class="pre">decode_params()</span></code>.</p>
</li>
<li><p class="first">The non-public function <code class="xref py py-func docutils literal"><span class="pre">email.Iterators._structure()</span></code> was added.</p>
</li>
</ul>
</div>
<div class="section" id="differences-from-mimelib">
<h2>19.1.16. Differences from <code class="xref py py-mod docutils literal"><span class="pre">mimelib</span></code><a class="headerlink" href="#differences-from-mimelib" title="Permalink to this headline">¶</a></h2>
<p>The <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package was originally prototyped as a separate library called
<a class="reference external" href="http://mimelib.sourceforge.net/">mimelib</a>. Changes have been made so that method names
are more consistent, and some methods or modules have either been added or
removed.  The semantics of some of the methods have also changed.  For the most
part, any functionality available in <code class="xref py py-mod docutils literal"><span class="pre">mimelib</span></code> is still available in the
<a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package, albeit often in a different way.  Backward compatibility
between the <code class="xref py py-mod docutils literal"><span class="pre">mimelib</span></code> package and the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> package was not a
priority.</p>
<p>Here is a brief description of the differences between the <code class="xref py py-mod docutils literal"><span class="pre">mimelib</span></code> and
the <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a> packages, along with hints on how to port your applications.</p>
<p>Of course, the most visible difference between the two packages is that the
package name has been changed to <a class="reference internal" href="#module-email" title="email: Package supporting the parsing, manipulating, and generating email messages, including MIME documents."><code class="xref py py-mod docutils literal"><span class="pre">email</span></code></a>.  In addition, the top-level
package has the following differences:</p>
<ul class="simple">
<li><code class="xref py py-func docutils literal"><span class="pre">messageFromString()</span></code> has been renamed to <a class="reference internal" href="email.parser.html#email.message_from_string" title="email.message_from_string"><code class="xref py py-func docutils literal"><span class="pre">message_from_string()</span></code></a>.</li>
<li><code class="xref py py-func docutils literal"><span class="pre">messageFromFile()</span></code> has been renamed to <a class="reference internal" href="email.parser.html#email.message_from_file" title="email.message_from_file"><code class="xref py py-func docutils literal"><span class="pre">message_from_file()</span></code></a>.</li>
</ul>
<p>The <a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> class has the following differences:</p>
<ul class="simple">
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">asString()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.as_string" title="email.message.Message.as_string"><code class="xref py py-meth docutils literal"><span class="pre">as_string()</span></code></a>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">ismultipart()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.is_multipart" title="email.message.Message.is_multipart"><code class="xref py py-meth docutils literal"><span class="pre">is_multipart()</span></code></a>.</li>
<li>The <a class="reference internal" href="email.message.html#email.message.Message.get_payload" title="email.message.Message.get_payload"><code class="xref py py-meth docutils literal"><span class="pre">get_payload()</span></code></a> method has grown a <em>decode</em>
optional argument.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getall()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.get_all" title="email.message.Message.get_all"><code class="xref py py-meth docutils literal"><span class="pre">get_all()</span></code></a>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">addheader()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.add_header" title="email.message.Message.add_header"><code class="xref py py-meth docutils literal"><span class="pre">add_header()</span></code></a>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">gettype()</span></code> was renamed to <code class="xref py py-meth docutils literal"><span class="pre">get_type()</span></code>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getmaintype()</span></code> was renamed to <code class="xref py py-meth docutils literal"><span class="pre">get_main_type()</span></code>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getsubtype()</span></code> was renamed to <code class="xref py py-meth docutils literal"><span class="pre">get_subtype()</span></code>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getparams()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.get_params" title="email.message.Message.get_params"><code class="xref py py-meth docutils literal"><span class="pre">get_params()</span></code></a>. Also, whereas <code class="xref py py-meth docutils literal"><span class="pre">getparams()</span></code>
returned a list of strings, <a class="reference internal" href="email.message.html#email.message.Message.get_params" title="email.message.Message.get_params"><code class="xref py py-meth docutils literal"><span class="pre">get_params()</span></code></a> returns
a list of 2-tuples, effectively the key/value pairs of the parameters, split
on the <code class="docutils literal"><span class="pre">'='</span></code> sign.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getparam()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.get_param" title="email.message.Message.get_param"><code class="xref py py-meth docutils literal"><span class="pre">get_param()</span></code></a>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getcharsets()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.get_charsets" title="email.message.Message.get_charsets"><code class="xref py py-meth docutils literal"><span class="pre">get_charsets()</span></code></a>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getfilename()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.get_filename" title="email.message.Message.get_filename"><code class="xref py py-meth docutils literal"><span class="pre">get_filename()</span></code></a>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getboundary()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.get_boundary" title="email.message.Message.get_boundary"><code class="xref py py-meth docutils literal"><span class="pre">get_boundary()</span></code></a>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">setboundary()</span></code> was renamed to
<a class="reference internal" href="email.message.html#email.message.Message.set_boundary" title="email.message.Message.set_boundary"><code class="xref py py-meth docutils literal"><span class="pre">set_boundary()</span></code></a>.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getdecodedpayload()</span></code> was removed.  To get similar
functionality, pass the value 1 to the <em>decode</em> flag of the
<a class="reference internal" href="email.message.html#email.message.Message.get_payload" title="email.message.Message.get_payload"><code class="xref py py-meth docutils literal"><span class="pre">get_payload()</span></code></a> method.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getpayloadastext()</span></code> was removed.  Similar functionality is
supported by the <a class="reference internal" href="email.generator.html#email.generator.DecodedGenerator" title="email.generator.DecodedGenerator"><code class="xref py py-class docutils literal"><span class="pre">DecodedGenerator</span></code></a> class in the
<a class="reference internal" href="email.generator.html#module-email.generator" title="email.generator: Generate flat text email messages from a message structure."><code class="xref py py-mod docutils literal"><span class="pre">email.generator</span></code></a> module.</li>
<li>The method <code class="xref py py-meth docutils literal"><span class="pre">getbodyastext()</span></code> was removed.  You can get similar
functionality by creating an iterator with
<a class="reference internal" href="email.iterators.html#email.iterators.typed_subpart_iterator" title="email.iterators.typed_subpart_iterator"><code class="xref py py-func docutils literal"><span class="pre">typed_subpart_iterator()</span></code></a> in the <a class="reference internal" href="email.iterators.html#module-email.iterators" title="email.iterators: Iterate over a  message object tree."><code class="xref py py-mod docutils literal"><span class="pre">email.iterators</span></code></a>
module.</li>
</ul>
<p>The <a class="reference internal" href="email.parser.html#email.parser.Parser" title="email.parser.Parser"><code class="xref py py-class docutils literal"><span class="pre">Parser</span></code></a> class has no differences in its public
interface. It does have some additional smarts to recognize
<em class="mimetype">message/delivery-status</em> type messages, which it represents as a
<a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> instance containing separate
<a class="reference internal" href="email.message.html#email.message.Message" title="email.message.Message"><code class="xref py py-class docutils literal"><span class="pre">Message</span></code></a> subparts for each header block in the delivery
status notification <a class="footnote-reference" href="#id2" id="id1">[1]</a>.</p>
<p>The <a class="reference internal" href="email.generator.html#email.generator.Generator" title="email.generator.Generator"><code class="xref py py-class docutils literal"><span class="pre">Generator</span></code></a> class has no differences in its public
interface.  There is a new class in the <a class="reference internal" href="email.generator.html#module-email.generator" title="email.generator: Generate flat text email messages from a message structure."><code class="xref py py-mod docutils literal"><span class="pre">email.generator</span></code></a> module though,
called <a class="reference internal" href="email.generator.html#email.generator.DecodedGenerator" title="email.generator.DecodedGenerator"><code class="xref py py-class docutils literal"><span class="pre">DecodedGenerator</span></code></a> which provides most of the
functionality previously available in the <code class="xref py py-meth docutils literal"><span class="pre">Message.getpayloadastext()</span></code>
method.</p>
<p>The following modules and classes have been changed:</p>
<ul>
<li><p class="first">The <a class="reference internal" href="email.mime.html#email.mime.base.MIMEBase" title="email.mime.base.MIMEBase"><code class="xref py py-class docutils literal"><span class="pre">MIMEBase</span></code></a> class constructor arguments <em>_major</em>
and <em>_minor</em> have changed to <em>_maintype</em> and <em>_subtype</em> respectively.</p>
</li>
<li><p class="first">The <code class="docutils literal"><span class="pre">Image</span></code> class/module has been renamed to <code class="docutils literal"><span class="pre">MIMEImage</span></code>.  The <em>_minor</em>
argument has been renamed to <em>_subtype</em>.</p>
</li>
<li><p class="first">The <code class="docutils literal"><span class="pre">Text</span></code> class/module has been renamed to <code class="docutils literal"><span class="pre">MIMEText</span></code>.  The <em>_minor</em>
argument has been renamed to <em>_subtype</em>.</p>
</li>
<li><p class="first">The <code class="docutils literal"><span class="pre">MessageRFC822</span></code> class/module has been renamed to <code class="docutils literal"><span class="pre">MIMEMessage</span></code>.  Note
that an earlier version of <code class="xref py py-mod docutils literal"><span class="pre">mimelib</span></code> called this class/module <code class="docutils literal"><span class="pre">RFC822</span></code>,
but that clashed with the Python standard library module <code class="xref py py-mod docutils literal"><span class="pre">rfc822</span></code> on some
case-insensitive file systems.</p>
<p>Also, the <a class="reference internal" href="email.mime.html#email.mime.message.MIMEMessage" title="email.mime.message.MIMEMessage"><code class="xref py py-class docutils literal"><span class="pre">MIMEMessage</span></code></a> class now represents any
kind of MIME message
with main type <em class="mimetype">message</em>.  It takes an optional argument <em>_subtype</em>
which is used to set the MIME subtype.  <em>_subtype</em> defaults to
<em class="mimetype">rfc822</em>.</p>
</li>
</ul>
<p><code class="xref py py-mod docutils literal"><span class="pre">mimelib</span></code> provided some utility functions in its <code class="xref py py-mod docutils literal"><span class="pre">address</span></code> and
<code class="xref py py-mod docutils literal"><span class="pre">date</span></code> modules.  All of these functions have been moved to the
<a class="reference internal" href="email.util.html#module-email.utils" title="email.utils: Miscellaneous email package utilities."><code class="xref py py-mod docutils literal"><span class="pre">email.utils</span></code></a> module.</p>
<p>The <code class="docutils literal"><span class="pre">MsgReader</span></code> class/module has been removed.  Its functionality is most
closely supported in the <a class="reference internal" href="email.iterators.html#email.iterators.body_line_iterator" title="email.iterators.body_line_iterator"><code class="xref py py-func docutils literal"><span class="pre">body_line_iterator()</span></code></a> function
in the <a class="reference internal" href="email.iterators.html#module-email.iterators" title="email.iterators: Iterate over a  message object tree."><code class="xref py py-mod docutils literal"><span class="pre">email.iterators</span></code></a> module.</p>
<p class="rubric">Footnotes</p>
<table class="docutils footnote" frame="void" id="id2" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id1">[1]</a></td><td>Delivery Status Notifications (DSN) are defined in <span class="target" id="index-9"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc1894.html"><strong>RFC 1894</strong></a>.</td></tr>
</tbody>
</table>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">19.1. <code class="docutils literal"><span class="pre">email</span></code> &#8212; An email and MIME handling package</a><ul>
<li><a class="reference internal" href="#package-history">19.1.15. Package History</a></li>
<li><a class="reference internal" href="#differences-from-mimelib">19.1.16. Differences from <code class="docutils literal"><span class="pre">mimelib</span></code></a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="netdata.html"
                        title="previous chapter">19. Internet Data Handling</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="email.message.html"
                        title="next chapter">19.1.1. <code class="docutils literal"><span class="pre">email.message</span></code>: Representing an email message</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/email.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="email.message.html" title="19.1.1. email.message: Representing an email message"
             >next</a> |</li>
        <li class="right" >
          <a href="netdata.html" title="19. Internet Data Handling"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="netdata.html" >19. Internet Data Handling</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>